'--------- Main_R1.bas --------------------
'Author: Hacker - DuinoMiteMegaAndy
'Date: 6/30/2011
'App. Version: Rev. 1.0b
'MMBasic Firmware: 3.2c on the DuinoMite Mega
'Platform: Win XP/SP3
'Application: MM/DM web server read/write and email test (PinkTest.bas)
'Needs custom web pages "index.htm" and "mesh_write.htm" installed on NetBurner SB70LC web server
'Com4 used as serial port for web server
'----------Code Begin--------------
Cls
? Date$,Time$,"NetBurner PINK SB70LC Web Server Test"
' open serial port for web server
NULL$ = Chr$(0) ' This null chr is need for data commands
Open "com4:9600,256" As #5
FlushRxBuf 5
'-----------------
' global variables
'-----------------
E1$ = "???????@??????.com" 'email to
E2$ = "Home Automation Alert!"  'email subject
E3$ = "High Temp" 'email content
varx = 400
'-----------------------------------------------

'-----------------------------
' Test Web Page Read / Write
'-----------------------------
Begin:
x$ = Str$(varx)
' Send 5 variables to web page
? "---------------------------"
? "write var 20"
? #5, "!NB0W20:"+ x$ + NULL$ ;
? "write var 21"
? #5, "!NB0W21:"+ x$ + NULL$ ;
? "write var 22"
? #5, "!NB0W22:"+ x$ + NULL$ ;
? "write var 23"
? #5, "!NB0W23:"+ x$ + NULL$ ;
? "write var 24"
? #5, "!NB0W24:"+ x$ + NULL$ ;

' Read 2 variables from web page
? "read var 00"
readvar "00" ' default False
Pause 1000
? "read var 01"
readvar "01" ' default False
? "---------------------------"
?
Pause 5000 ' 5 secs
GoTo begin
End
'-----------------------------



'-----------
'Subroutines
'-----------

'----------------
' SMTP email send
'----------------

'--------
Sub Test1 'Send complete email setup to webserver
send_email_long
Pause 10000 ' wait 10 secs before checking status
check_email_status
End Sub
'--------

'--------
Sub Test2 'Send short email setup to webserver - rest is stored on web page
send_email_short e1$, e2$, e3$
Pause 10000 ' wait 10 secs before checking status
check_email_status
End Sub
'--------

'--------
Sub Test3 ' Command only to send email-All setup done in flash on webserver page
send_email_very_short
Pause 10000 ' wait 10 secs before checking status
check_email_status
End Sub
'--------

'------------------------------
Sub send_email_long
? #5, "!NB0WET:???????????"+ Null$ ; 'email to
? #5, "!NB0WEF:???????????"+ Null$ ; 'email from
? #5, "!NB0WES:Home Automation Alert!"+ Null$ ; 'email subject
? #5, "!NB0WEC:High Temperature"+ Null$ ; 'email content
? #5, "!NB0WEV:???????????.com"+ Null$ ; 'email SMTP server
? #5, "!NB0WEU:???????????@?????.com"+ Null$ ; 'email email username
? #5, "!NB0WEP:userpassword"+ Null$ ; 'email email password
? #5, "!NB0WEA:S"+ Null$ ; 'email authenication
? #5, "!NB0WEW:465"+ Null$ ; 'email port number
? #5, "!NB0SM" ; 'command to send email command
End Sub
'------------------------------

'------------------------------
Sub send_email_short (x$, y$, z$)
'All other email setup already in web server flash
? #5, "!NB0WET:"+ x$ + Null$ ; 'email to
? #5, "!NB0WES:"+ y$ + Null$ ; 'email subject
? #5, "!NB0WEC:"+ z$ + Null$ ; 'email content
? #5, "!NB0SM" ;                 'command to send email command
End Sub
'------------------------------

'------------------------
Sub send_email_very_short ' use all fixed values in flash
? #5, "!NB0SM" ; ' send email command
End Sub
'-------------------------

'------------------------------
Sub check_email_status
? #5, "!NB0RST" ;  ' returns 11<0> good or 1<0> bad
Start:
Pause 1000
Loopx:
Rx$ = Input$(30,#5)
If (Eof(5) = False) Then GoTo loopx
? "Email Status (11 Good) (1 Bad) = " Rx$
FlushRxBuf 5
End Sub
'------------------------------

'------------------------------
Sub FlushRxBuf (nbr)
Local RecBuf$
Loopx:
RecBuf$ = Input$(30,nbr)
If (Eof(nbr) = False) Then GoTo loopx
RecBuf$ = ""
End Sub
'-------------------------------

'------------------------------
' reading and writing to SB70LC
'------------------------------
'--------
Sub Test5
WriteStr20
End Sub
'--------

'--------
Sub Test6
'WriteVar21 (300) '300
WriteVar21 (varx) 'global var 400
End Sub
'--------

'--------
Sub Test7
ReadVar21
End Sub
'--------

'-------------------------------
' PINK SB70LC Write string "200" to NB_var20 (ram)
'-------------------------------
Sub WriteStr20 ' RAM Location on web page
? #5, "!NB0W20:200" + NULL$ ; ' semicolon = supress CR LF
End Sub
'--------------------------------

'-------------------------------
' PINK SB70LC Write var 300 or 400 to NB_var21 (ram)
'-------------------------------
Sub WriteVar21 (var) ' RAM Location on web page
x$ = Str$(var)
? #5, "!NB0W21:"+ x$ + NULL$ ;
End Sub
'--------------------------------

'-------------------------------
' PINK SB70LC Read var NB_var21 (ram)
'-------------------------------
Sub ReadVar21
? #5, "!NB0R21" 'command to read NB_var21
Start1:
Pause 1000
Loop1:
Rx$ = Input$(30,#5)
If (Eof(5) = False) Then GoTo loop1
? "NB_var21 = " Rx$
FlushRxBuf 5
End Sub
'--------------------------------


'-------------------------------
' PINK SB70LC Read var NB_varxx (ram)
'-------------------------------

Sub ReadVar (var$) 'string "00" to "99'
? #5, "!NB0R"+ var$ 'command to read NB_varXX
Start2:
Pause 1000
Loop2:
Rx$ = Input$(30,#5)
If (Eof(5) = False) Then GoTo loop2
? "NB_var"+ var$ + " = " Rx$
FlushRxBuf 5
End Sub
'-------------------------------
End
                                                                                                                             